from pathlib import Path
import os
import sys

v = sys.version_info
if sys.platform == 'win32':
    TALON_HOME = Path(os.getenv('APPDATA', Path.home())) / 'talon'
    prefix = TALON_HOME / 'venv' / f"{v.major}.{v.minor}"
    sys.prefix = str(prefix)
    sys.exec_prefix = str(prefix)
    sys.executable = str(prefix / 'Scripts' / 'python.exe')
else:
    TALON_HOME = Path.home() / '.talon'
    prefix = TALON_HOME / '.venv'
    sys.prefix = str(prefix)
    sys.exec_prefix = str(prefix)
    sys.executable = str(prefix / 'bin' / 'python')

import site
known_paths = set(sys.path)
site.addsitepackages(known_paths, [sys.prefix])
