from talon import app as app
from talon.skia import Image as Image
from typing import Generator, Optional

class MimeData:
    @property
    def formats(self) -> list[str]: ...
    text: Optional[str]
    rtf: Optional[str]
    html: Optional[str]
    urls: Optional[list[str]]
    image: Optional[Image]
    color: Optional[tuple[float, float, float, float]]
    def raw(self, key: str) -> Optional[bytes]: ...
    def set_raw(self, key: str, value: Optional[bytes]) -> None: ...

def has_mode(mode: str) -> bool: ...
def mime(*, mode: str = ..., tries: int = ..., formats: list[str] = ...) -> Optional[MimeData]: ...
def set_mime(mime: Optional[MimeData], *, mode: str = ...) -> None: ...
def text(*, mode: str = ...) -> Optional[str]: ...
def set_text(s: str, *, mode: str = ...) -> None: ...
def get() -> Optional[str]: ...
def set(s: str): ...
def image(*, mode: str = ...) -> Optional[Image]: ...
def set_image(image: Image, *, mode: str = ...) -> None: ...
def clear(*, mode: str = ...) -> None: ...
def serial(*, mode: str = ...) -> int: ...
def await_change(timeout: float = ..., *, after: int = ..., old: MimeData = ..., mode: str = ..., formats: list[str] = ...) -> Optional[MimeData]: ...

class NoChange(Exception): ...

class ChangePromise:
    data: Optional[MimeData]
    complete: bool
    def __bool__(self) -> bool: ...
    def mime(self) -> MimeData: ...
    def text(self) -> Optional[str]: ...
    def get(self) -> Optional[str]: ...

def revert(*, old: MimeData = ..., mode: str = ...) -> Generator[None, None, None]: ...
def capture(timeout: float = ..., *, inc: int = ..., mode: str = ..., formats: list[str] = ...) -> Generator[ChangePromise, None, None]: ...
