from _typeshed import Incomplete
from traceback import FrameSummary
from types import FrameType, TracebackType
from typing import Any, Callable, Generator, Iterator, Optional, Tuple, TypeVar

DecoratedT = TypeVar('DecoratedT', bound=Callable[..., Any])
DecoratorType = Callable[[DecoratedT], DecoratedT]
roots: Tuple
stdlib_paths: Tuple

class StackNote:
    tag: Optional[str]
    label: Optional[str]
    collapse: Optional[str]
    def __init__(self, tag, label, collapse) -> None: ...

class StackNotes:
    notes: dict[int, list[StackNote]]
    def __init__(self) -> None: ...
    def label_frame(self, *, tag: str = ..., label: str = ..., collapse: str = ..., offset: int = ...) -> Iterator[None]: ...
    def label_thread(self, *, tag: str = ..., label: str = ..., collapse: str = ...) -> Iterator[None]: ...
    def collapse_thread(self, *, tag: str, label: str, offset: int = ...) -> Iterator[None]: ...

label_thread: Incomplete
label_frame: Incomplete
collapse_thread: Incomplete

def safe_relpath(path: str, root: str) -> str: ...
def shortest_relpath(path: str) -> str: ...

class StackFrame:
    id: int
    detail: FrameSummary
    collapsed: bool
    @property
    def short_path(self): ...
    def __init__(self, id, detail, collapsed) -> None: ...

def format_frames(stack: list[StackFrame]) -> list[str]: ...
def frame_stack(frame: FrameType = ..., *, tid: int = ...) -> list[StackFrame]: ...
def frame_tb(tb: TracebackType = ...) -> tuple[list[StackFrame], str]: ...
def format_tb(tb: TracebackType = ...) -> list[str]: ...
def format_stack(frame: FrameType = ..., *, tid: int = ...) -> list[str]: ...
def print_stack(frame: FrameType = ...) -> None: ...
def splice_tb(stack: list[StackFrame], tb: TracebackType = ...) -> list[str]: ...
def dump_threads() -> str: ...
def print_threads() -> None: ...
def log_exception_chain(e: BaseException = ...) -> list[str]: ...
def log_exception(msg: str, exc: BaseException = ..., splice: bool = ...) -> None: ...
def object_name(obj: Any, fallback: str = ..., module: bool = ...) -> str: ...
def objects() -> Iterator[Any]: ...
def timeit(name: str = ...) -> Generator[None, None, None]: ...
