from _typeshed import Incomplete
from talon import app as app
from talon.api import ffi as ffi, ffi_string as ffi_string, lib as lib
from talon.skia import Image as Image
from talon.types import Rect as Rect
from typing import Union

class Bounds:
    rects: list[Rect]
    def __getitem__(self, key: Union[int, slice]) -> Rect: ...
    def __init__(self, rects) -> None: ...

class Result:
    text: str
    confidence: float
    rect: Rect
    bounds: Bounds
    def __init__(self, text, confidence, rect, bounds) -> None: ...

class Backend:
    def ocr(self, image: Image) -> list[Result]: ...

class BackendMac(Backend):
    def __init__(self) -> None: ...
    def ocr(self, image: Image) -> list[Result]: ...

class BackendWindows(Backend):
    actor: Incomplete
    def __init__(self) -> None: ...
    def ocr(self, image: Image) -> list[Result]: ...

def ocr(image: Image) -> list[Result]: ...
