from _typeshed import Incomplete
from talon import cron as cron, metrics as metrics
from talon.grammar import rule as rule, vm as vm
from talon.grammar.dfa import NFA as NFA
from talon.grammar.parser import Node as Node
from talon.grammar.vm import State as State
from typing import Callable, Iterable, Optional, Union

ListTypeSimple = Union[str, list[str], dict[str, str]]
ListTypeFull = Union[ListTypeSimple, Callable[[], ListTypeSimple]]
DynamicListFunc = Callable[[], ListTypeSimple]

class GrammarError(Exception): ...

class Grammar:
    vm: Optional[vm.VM]
    lists: dict[str, Union[str, set[str]]]
    list_nfas: dict[str, NFA]
    dynamic_lists: dict[str, DynamicListFunc]
    rules: dict[str, tuple[rule.Rule, bool]]
    compiled: bool
    main_root: Optional[Node]
    enabled: bool
    exclusive: bool
    priority: int
    name: Incomplete
    grammar: Incomplete
    def __init__(self, name) -> None: ...
    def add_rule(self, name: str, rule: rule.Rule, public: bool = ...) -> None: ...
    def compile(self, main_rule: str): ...
    def parse(self, words: Iterable[str]) -> list[State]: ...
    def update_lists(self, lists: ListTypeFull, partial: bool = ...) -> None: ...
