import os
import typing
from typing import Iterator, Optional

class FsEvent:
    path: str
    stat: Optional[os.stat_result]
    def __init__(self, path: str, st: os.stat_result = ...) -> None: ...

class FsCreate(FsEvent): ...
class FsModify(FsEvent): ...
class FsRemove(FsEvent): ...

class FsEntry:
    path: str
    stat: Optional[os.stat_result]
    entries: dict[str, 'FsEntry']
    def __init__(self, path: str, st: os.stat_result = ...) -> None: ...
    def rescan(self, parents: frozenset[str] = ..., dir_entry: os.DirEntry = ...) -> Iterator[FsEvent]: ...
    def walk(self) -> Iterator['FsEntry']: ...
    def drain(self) -> Iterator[FsRemove]: ...
    def dump(self, indent: str = ..., top: bool = ...) -> str: ...

class FsShadow:
    entries: dict[str, FsEntry]
    prefix_re: Optional[typing.Pattern]
    def __init__(self) -> None: ...
    def rescan(self) -> Iterator[FsEvent]: ...
    def watch(self, path: str) -> None: ...
    def unwatch(self, path: str) -> None: ...
    def paths(self) -> list[str]: ...
    def walk(self, path: str = ...) -> Iterator[FsEntry]: ...
    def all_paths(self) -> list[str]: ...
    def dump(self) -> str: ...
