import threading
from _typeshed import Incomplete
from talon import ui
from talon.linux.xclient import XClient
from typing import Optional

class LRUKey:
    sym: int
    code: int
    nonce: int
    def __lt__(self, other) -> bool: ...
    def __init__(self, sym, code, nonce) -> None: ...

class KeyMapper:
    xclient: XClient
    keycodes: set[int]
    lock: threading.RLock
    pool: set[int]
    lru: dict[int, LRUKey]
    hits: int
    misses: int
    nonce: int
    def __init__(self, xclient: XClient, count: int = ...) -> None: ...
    def __contains__(self, code_or_sym: int) -> bool: ...
    def allocate(self, keysym: int) -> int: ...
    def find(self, keysym: int) -> int: ...

class InputClient:
    xclient: Incomplete
    key_mapper: Incomplete
    xinput2_first_event: Incomplete
    def __init__(self, xclient: XClient) -> None: ...
    def FakeInput(self, event: int, detail: int, *, time: int = ..., root: Optional[int] = ..., x: int = ..., y: int = ..., device_id: int = ..., is_checked: bool = ...): ...
    def flush(self) -> None: ...
    def key_press(self, key: str, *, super: bool = ..., shift: bool = ..., ctrl: bool = ..., alt: bool = ..., fn: bool = ..., down: bool = ..., up: bool = ..., hold: int = ..., wait: int = ..., app: ui.App = ..., **kwargs) -> None: ...
    def mouse_click(self, button: int = ..., times: int = ..., *, pos: tuple[float, float] = ..., down: bool = ..., up: bool = ..., hold: int = ..., wait: int = ..., app: ui.App = ...) -> None: ...
    def mouse_move(self, x: float, y: float, *, dx: float = ..., dy: float = ..., app: ui.App = ...): ...
    def mouse_scroll(self, y: float = ..., x: float = ..., *, pos: tuple[float, float] = ..., by_lines: bool = ..., app: ui.App = ...) -> None: ...
    def mouse_pos(self) -> tuple[float, float]: ...
    def cursor_visible(self, value: bool) -> None: ...
    def mouse_buttons_down(self) -> set[int]: ...

key_press: Incomplete
mouse_move: Incomplete
mouse_click: Incomplete
mouse_scroll: Incomplete
mouse_pos: Incomplete
cursor_visible: Incomplete
mouse_buttons_down: Incomplete
