import threading
from .module import Module as Module
from .registry import Decls as Decls, Registry as Registry
from _typeshed import Incomplete
from contextvars import ContextVar
from talon import events as events
from talon.scripting.dispatch import Dispatch as Dispatch
from talon.scripting.types import ImmutableClassMeta as ImmutableClassMeta, parse_doc as parse_doc
from typing import Any, Callable, Optional

ScopeFunc = Callable[[], dict]

class ScopeDecl(Dispatch):
    mod: Incomplete
    path: Incomplete
    func: Incomplete
    desc: Incomplete
    def __init__(self, mod: Module, path: str, func: ScopeFunc) -> None: ...
    def update(self, *args) -> None: ...

class Scope(Dispatch, metaclass=ImmutableClassMeta):
    app_decl: ContextVar[Optional[str]]
    lock: threading.RLock
    registry: Registry
    data: dict[str, dict]
    data_sources: dict[str, set]
    raw_data: dict[str, dict]
    scopes: dict[str, ScopeDecl]
    registered: set[ScopeDecl]
    def __init__(self, registry: Registry) -> None: ...
    def key(self, path: str) -> tuple[str, Optional[str]]: ...
    def get(self, path: str, default: Any = ...) -> Any: ...
    def __contains__(self, path: str) -> bool: ...
    def __getitem__(self, path: str) -> Any: ...
    def update(self, path: str) -> None: ...
    def update_one(self, scope: ScopeDecl) -> None: ...
    def update_decls(self, decls: Decls) -> None: ...
