from _typeshed import Incomplete
from talon.types import Point2d as Point2d, Rect as Rect

ax: Incomplete

class Element:
    el: Incomplete
    def __init__(self, el) -> None: ...
    @property
    def pid(self) -> int: ...
    @property
    def control_type(self) -> str: ...
    @property
    def localized_control_type(self) -> str: ...
    @property
    def name(self) -> str: ...
    @property
    def accelerator_key(self) -> str: ...
    @property
    def access_key(self) -> str: ...
    @property
    def has_keyboard_focus(self) -> bool: ...
    @property
    def is_keyboard_focusable(self) -> bool: ...
    @property
    def is_enabled(self) -> bool: ...
    @property
    def automation_id(self) -> str: ...
    @property
    def class_name(self) -> str: ...
    @property
    def help_text(self) -> str: ...
    @property
    def culture(self) -> int: ...
    @property
    def is_control_element(self) -> bool: ...
    @property
    def is_content_element(self) -> bool: ...
    @property
    def is_password(self) -> bool: ...
    @property
    def window_handle(self) -> int: ...
    @property
    def item_type(self) -> str: ...
    @property
    def is_offscreen(self) -> bool: ...
    @property
    def orientation(self) -> str: ...
    @property
    def framework_id(self) -> str: ...
    @property
    def is_required_form(self) -> bool: ...
    @property
    def item_status(self) -> str: ...
    @property
    def rect(self) -> Rect: ...
    @property
    def labeled_by(self) -> Element: ...
    @property
    def aria_role(self) -> str: ...
    @property
    def aria_properties(self) -> str: ...
    @property
    def controller_for(self) -> list['Element']: ...
    @property
    def described_by(self) -> list['Element']: ...
    @property
    def flows_to(self) -> list['Element']: ...
    @property
    def provider_description(self) -> str: ...
    @property
    def children(self) -> list['Element']: ...
    @property
    def clickable_point(self) -> Point2d: ...
    @property
    def patterns(self) -> list[str]: ...
    @property
    def annotation_pattern(self) -> AnnotationPattern: ...
    @property
    def customnavigation_pattern(self) -> CustomNavigationPattern: ...
    @property
    def dock_pattern(self) -> DockPattern: ...
    @property
    def drag_pattern(self) -> DragPattern: ...
    @property
    def droptarget_pattern(self) -> DropTargetPattern: ...
    @property
    def expandcollapse_pattern(self) -> ExpandCollapsePattern: ...
    @property
    def griditem_pattern(self) -> GridItemPattern: ...
    @property
    def grid_pattern(self) -> GridPattern: ...
    @property
    def invoke_pattern(self) -> InvokePattern: ...
    @property
    def itemcontainer_pattern(self) -> ItemContainerPattern: ...
    @property
    def legacyiaccessible_pattern(self) -> LegacyIAccessiblePattern: ...
    @property
    def multipleview_pattern(self) -> MultipleViewPattern: ...
    @property
    def objectmodel_pattern(self) -> ObjectModelPattern: ...
    @property
    def rangevalue_pattern(self) -> RangeValuePattern: ...
    @property
    def scrollitem_pattern(self) -> ScrollItemPattern: ...
    @property
    def scroll_pattern(self) -> ScrollPattern: ...
    @property
    def selectionitem_pattern(self) -> SelectionItemPattern: ...
    @property
    def selection_pattern(self) -> SelectionPattern: ...
    @property
    def selection_pattern2(self) -> SelectionPattern2: ...
    @property
    def spreadsheetitem_pattern(self) -> SpreadsheetItemPattern: ...
    @property
    def spreadsheet_pattern(self) -> SpreadsheetPattern: ...
    @property
    def styles_pattern(self) -> StylesPattern: ...
    @property
    def synchronizedinput_pattern(self) -> SynchronizedInputPattern: ...
    @property
    def tableitem_pattern(self) -> TableItemPattern: ...
    @property
    def table_pattern(self) -> TablePattern: ...
    @property
    def textchild_pattern(self) -> TextChildPattern: ...
    @property
    def textedit_pattern(self) -> TextEditPattern: ...
    @property
    def text_pattern(self) -> TextPattern: ...
    @property
    def text_pattern2(self) -> TextPattern2: ...
    @property
    def toggle_pattern(self) -> TogglePattern: ...
    @property
    def transform_pattern(self) -> TransformPattern: ...
    @property
    def transform_pattern2(self) -> TransformPattern2: ...
    @property
    def value_pattern(self) -> ValuePattern: ...
    @property
    def virtualizeditem_pattern(self) -> VirtualizedItemPattern: ...
    @property
    def window_pattern(self) -> WindowPattern: ...
    def __del__(self) -> None: ...

class Pattern:
    pattern: Incomplete
    def __init__(self, pattern) -> None: ...

class ExpandCollapsePattern(Pattern):
    def expand(self) -> None: ...
    def collapse(self) -> None: ...
    @property
    def state(self) -> str: ...

class InvokePattern(Pattern):
    def invoke(self) -> None: ...

class LegacyIAccessiblePattern(Pattern):
    def do_default_action(self) -> None: ...
    @property
    def child_id(self) -> str: ...
    @property
    def default_action(self) -> str: ...
    @property
    def description(self) -> str: ...
    @property
    def help(self) -> str: ...
    @property
    def keyboard_shortcut(self) -> str: ...
    @property
    def name(self) -> str: ...
    @property
    def role(self) -> str: ...
    @property
    def state(self) -> int: ...
    @property
    def value(self) -> str: ...
    @property
    def selection(self) -> list['Element']: ...
    def select(self) -> None: ...

class RangeValuePattern(Pattern):
    @property
    def value(self) -> float: ...
    @property
    def is_read_only(self) -> bool: ...
    @property
    def maximum(self) -> float: ...
    @property
    def minimum(self) -> float: ...
    @property
    def large_change(self) -> float: ...
    @property
    def small_change(self) -> float: ...

class TogglePattern(Pattern):
    def toggle(self) -> None: ...
    @property
    def state(self) -> str: ...

class TransformPattern(Pattern):
    def move(self, x: float, y: float) -> None: ...
    def resize(self, width: float, height: float) -> None: ...
    def rotate(self, degrees: float) -> None: ...
    @property
    def can_move(self) -> bool: ...
    @property
    def can_resize(self) -> bool: ...
    @property
    def can_rotate(self) -> bool: ...

class TransformPattern2(Pattern):
    def move(self, x: float, y: float) -> None: ...
    def resize(self, width: float, height: float) -> None: ...
    def rotate(self, degrees: float) -> None: ...
    @property
    def can_move(self) -> bool: ...
    @property
    def can_resize(self) -> bool: ...
    @property
    def can_rotate(self) -> bool: ...
    def zoom(self, value: float) -> None: ...
    def zoom_by_unit(self, unit: str) -> None: ...
    @property
    def can_zoom(self) -> bool: ...
    @property
    def zoom_level(self) -> float: ...
    @property
    def zoom_minimum(self) -> float: ...
    @property
    def zoom_maximum(self) -> float: ...

class ScrollPattern(Pattern):
    def scroll(self, horizontal: float, vertical: float) -> None: ...
    def set_scroll_percent(self, horizontal: float, vertical: float) -> None: ...
    @property
    def horizontal_percent(self) -> float: ...
    @property
    def vertical_percent(self) -> float: ...
    @property
    def horizontal_size(self) -> float: ...
    @property
    def vertical_size(self) -> float: ...
    @property
    def horizontally_scrollable(self) -> bool: ...
    @property
    def vertically_scrollable(self) -> bool: ...

class TextRange:
    obj: Incomplete
    def __init__(self, obj) -> None: ...
    def __eq__(self, other) -> bool: ...
    def __ne__(self, other) -> bool: ...
    def clone(self) -> TextRange: ...
    def expand_to_enclosing_unit(self, unit: str) -> None: ...
    def find_text(self, text: str, *, backward: bool = ..., ignorecase: bool = ...) -> TextRange: ...
    @property
    def enclosing_element(self) -> Element: ...
    @property
    def text(self) -> str: ...
    def get_text(self, maxlength: int) -> str: ...
    def move(self, unit: str, count: int) -> int: ...
    def select(self) -> None: ...
    def add_to_selection(self) -> None: ...
    def remove_from_selection(self) -> None: ...
    def scroll_into_view(self, align_to_top: bool = ...) -> None: ...
    @property
    def children(self) -> list[Element]: ...

class TextPattern2(Pattern):
    def range_from_point(self, x: int, y: int) -> TextRange: ...
    def range_from_child(self, element: Element) -> TextRange: ...
    @property
    def selection(self) -> list[TextRange]: ...
    @property
    def visible_ranges(self) -> list[TextRange]: ...
    @property
    def document_range(self) -> TextRange: ...
    @property
    def supported_text_selection(self) -> str: ...
    def range_from_annotation(self, annotation) -> TextRange: ...
    @property
    def caret_range(self) -> TextRange: ...

class ValuePattern(Pattern):
    @property
    def value(self) -> str: ...
    @property
    def is_read_only(self) -> bool: ...

class WindowPattern(Pattern):
    def close(self): ...
    def wait_for_input_idle(self, milliseconds: int) -> None: ...
    @property
    def can_maximize(self) -> bool: ...
    @property
    def can_minimize(self) -> bool: ...
    @property
    def is_modal(self) -> bool: ...
    @property
    def is_topmost(self) -> bool: ...
    @property
    def interaction_state(self) -> str: ...
    @property
    def visual_state(self) -> str: ...

def get_root_element() -> Element: ...
def get_element_from_point(x: int, y: int) -> Element: ...
def get_focused_element() -> Element: ...
def get_element_from_handle(hwnd: int) -> Element: ...
